class DemoActionController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ demoActionList: DemoAction.list( params ) ]
    }

    def show = {
        def demoAction = DemoAction.get( params.id )

        if(!demoAction) {
            flash.message = "DemoAction not found with id ${params.id}"
            redirect(action:list)
        }
        else { return [ demoAction : demoAction ] }
    }

    def delete = {
        def demoAction = DemoAction.get( params.id )
        if(demoAction) {
            demoAction.delete()
            flash.message = "DemoAction ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "DemoAction not found with id ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
        def demoAction = DemoAction.get( params.id )

        if(!demoAction) {
            flash.message = "DemoAction not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ demoAction : demoAction ]
        }
    }

    def update = {
        def demoAction = DemoAction.get( params.id )
        if(demoAction) {
            demoAction.properties = params
            if(!demoAction.hasErrors() && demoAction.save()) {
                flash.message = "DemoAction ${params.id} updated"
                redirect(action:show,id:demoAction.id)
            }
            else {
                render(view:'edit',model:[demoAction:demoAction])
            }
        }
        else {
            flash.message = "DemoAction not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def create = {
        def demoAction = new DemoAction()
        demoAction.properties = params
        return ['demoAction':demoAction]
    }

    def save = {
        def demoAction = new DemoAction(params)
        if(!demoAction.hasErrors() && demoAction.save()) {
            flash.message = "DemoAction ${demoAction.id} created"
            redirect(action:show,id:demoAction.id)
        }
        else {
            render(view:'create',model:[demoAction:demoAction])
        }
    }
}
