class JobActionController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ jobActionList: JobAction.list( params ) ]
    }

    def show = {
        def jobAction = JobAction.get( params.id )

        if(!jobAction) {
            flash.message = "JobAction not found with id ${params.id}"
            redirect(action:list)
        }
        else { return [ jobAction : jobAction ] }
    }

    def delete = {
        def jobAction = JobAction.get( params.id )
        if(jobAction) {
            jobAction.delete()
            flash.message = "JobAction ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "JobAction not found with id ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
        def jobAction = JobAction.get( params.id )

        if(!jobAction) {
            flash.message = "JobAction not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ jobAction : jobAction ]
        }
    }

    def update = {
        def jobAction = JobAction.get( params.id )
        if(jobAction) {
            jobAction.properties = params
            if(!jobAction.hasErrors() && jobAction.save()) {
                flash.message = "JobAction ${params.id} updated"
                redirect(action:show,id:jobAction.id)
            }
            else {
                render(view:'edit',model:[jobAction:jobAction])
            }
        }
        else {
            flash.message = "JobAction not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def create = {
        def jobAction = new JobAction()
        jobAction.properties = params
        return ['jobAction':jobAction]
    }

    def save = {
        def jobAction = new JobAction(params)
        if(!jobAction.hasErrors() && jobAction.save()) {
            flash.message = "JobAction ${jobAction.id} created"
            redirect(action:show,id:jobAction.id)
        }
        else {
            render(view:'create',model:[jobAction:jobAction])
        }
    }
}
