class JobController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ jobList: Job.list( params ) ]
    }

def editNew = {}
    def show = {
        def job = Job.get( params.id )

        if(!job) {
            flash.message = "Job not found with id ${params.id}"
            redirect(action:list)
        }
        else { return [ job : job ] }
    }

    def delete = {
        def job = Job.get( params.id )
        if(job) {
            job.delete()
            flash.message = "Job ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "Job not found with id ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
        def job = Job.get( params.id )

        if(!job) {
            flash.message = "Job not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ job : job ]
        }
    }

    def update = {
        def job = Job.get( params.id )
        if(job) {
            job.properties = params
            if(!job.hasErrors() && job.save()) {
                flash.message = "Job ${params.id} updated"
                redirect(action:show,id:job.id)
            }
            else {
                render(view:'edit',model:[job:job])
            }
        }
        else {
            flash.message = "Job not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def create = {
        def job = new Job()
        job.properties = params
        return ['job':job]
    }

    def save = {
        def job = new Job(params)
        if(!job.hasErrors() && job.save()) {
            flash.message = "Job ${job.id} created"
            redirect(action:show,id:job.id)
        }
        else {
            render(view:'create',model:[job:job])
        }
    }
}
